"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const antlr4ts_1 = require("antlr4ts");
const RelativeDateFormatLexer_1 = require("./lib/lexer-parser/RelativeDateFormatLexer");
const RelativeDateFormatParser_1 = require("./lib/lexer-parser/RelativeDateFormatParser");
const RDFFunctionFactory_1 = require("./resolvers/RDFFunctionFactory");
// Create the lexer and parser
function RDF(rdfString, now) {
    const functionFactory = new RDFFunctionFactory_1.RDFFunctionFactory();
    let inputStream = new antlr4ts_1.ANTLRInputStream(rdfString);
    let lexer = new RelativeDateFormatLexer_1.RelativeDateFormatLexer(inputStream);
    let tokenStream = new antlr4ts_1.CommonTokenStream(lexer);
    let parser = new RelativeDateFormatParser_1.RelativeDateFormatParser(tokenStream);
    let directive = parser.directive();
    return functionFactory.visit(directive).solve();
}
exports.default = RDF;
