import { ATN } from "antlr4ts/atn/ATN";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { RuleContext } from "antlr4ts/RuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { RelativeDateFormatListener } from "./RelativeDateFormatListener";
import { RelativeDateFormatVisitor } from "./RelativeDateFormatVisitor";
export declare class RelativeDateFormatParser extends Parser {
    static readonly NOW = 1;
    static readonly SECONDS = 2;
    static readonly MINUTES = 3;
    static readonly HOURS = 4;
    static readonly DAYS = 5;
    static readonly WEEKS = 6;
    static readonly MONTHS = 7;
    static readonly QUARTERS = 8;
    static readonly YEARS = 9;
    static readonly RANGE = 10;
    static readonly TRAIL = 11;
    static readonly PERIOD = 12;
    static readonly OP_MIN = 13;
    static readonly OP_ADD = 14;
    static readonly NUMBER = 15;
    static readonly SEPERATOR = 16;
    static readonly WS = 17;
    static readonly RULE_directive = 0;
    static readonly RULE_relativeExpression = 1;
    static readonly RULE_resolvableExpression = 2;
    static readonly RULE_staticExpression = 3;
    static readonly RULE_staticPeriod = 4;
    static readonly RULE_relativePeriod = 5;
    static readonly RULE_unaryExpr = 6;
    static readonly RULE_staticIdentifier = 7;
    static readonly RULE_relativeIdentifier = 8;
    static readonly RULE_handler = 9;
    static readonly RULE_timestamp = 10;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    readonly vocabulary: Vocabulary;
    readonly grammarFileName: string;
    readonly ruleNames: string[];
    readonly serializedATN: string;
    constructor(input: TokenStream);
    directive(): DirectiveContext;
    relativeExpression(): RelativeExpressionContext;
    resolvableExpression(): ResolvableExpressionContext;
    staticExpression(): StaticExpressionContext;
    staticExpression(_p: number): StaticExpressionContext;
    staticPeriod(): StaticPeriodContext;
    relativePeriod(): RelativePeriodContext;
    unaryExpr(): UnaryExprContext;
    staticIdentifier(): StaticIdentifierContext;
    relativeIdentifier(): RelativeIdentifierContext;
    handler(): HandlerContext;
    timestamp(): TimestampContext;
    sempred(_localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private staticExpression_sempred;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static readonly _ATN: ATN;
}
export declare class DirectiveContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    copyFrom(ctx: DirectiveContext): void;
}
export declare class RangeDirectiveContext extends DirectiveContext {
    _begin: ResolvableExpressionContext;
    _end: ResolvableExpressionContext;
    SEPERATOR(): TerminalNode[];
    SEPERATOR(i: number): TerminalNode;
    RANGE(): TerminalNode;
    resolvableExpression(): ResolvableExpressionContext[];
    resolvableExpression(i: number): ResolvableExpressionContext;
    constructor(ctx: DirectiveContext);
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class TrailDirectiveContext extends DirectiveContext {
    _end: ResolvableExpressionContext;
    _period: RelativeExpressionContext;
    SEPERATOR(): TerminalNode[];
    SEPERATOR(i: number): TerminalNode;
    TRAIL(): TerminalNode;
    resolvableExpression(): ResolvableExpressionContext;
    relativeExpression(): RelativeExpressionContext | undefined;
    constructor(ctx: DirectiveContext);
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class PeriodDirectiveContext extends DirectiveContext {
    _begin: ResolvableExpressionContext;
    _period: RelativeExpressionContext;
    _ref: ResolvableExpressionContext;
    SEPERATOR(): TerminalNode[];
    SEPERATOR(i: number): TerminalNode;
    PERIOD(): TerminalNode;
    resolvableExpression(): ResolvableExpressionContext[];
    resolvableExpression(i: number): ResolvableExpressionContext;
    relativeExpression(): RelativeExpressionContext | undefined;
    constructor(ctx: DirectiveContext);
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class RelativeExpressionContext extends ParserRuleContext {
    resolvableExpression(): ResolvableExpressionContext | undefined;
    relativePeriod(): RelativePeriodContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class ResolvableExpressionContext extends ParserRuleContext {
    _rel: RelativePeriodContext;
    staticPeriod(): StaticPeriodContext | undefined;
    staticExpression(): StaticExpressionContext | undefined;
    relativePeriod(): RelativePeriodContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class StaticExpressionContext extends ParserRuleContext {
    _first: StaticExpressionContext;
    _staticPeriod: StaticPeriodContext;
    _then: StaticPeriodContext[];
    timestamp(): TimestampContext | undefined;
    NOW(): TerminalNode | undefined;
    staticExpression(): StaticExpressionContext | undefined;
    staticPeriod(): StaticPeriodContext[];
    staticPeriod(i: number): StaticPeriodContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class StaticPeriodContext extends ParserRuleContext {
    unaryExpr(): UnaryExprContext | undefined;
    staticIdentifier(): StaticIdentifierContext;
    NUMBER(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class RelativePeriodContext extends ParserRuleContext {
    unaryExpr(): UnaryExprContext | undefined;
    relativeIdentifier(): RelativeIdentifierContext;
    NUMBER(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class UnaryExprContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    copyFrom(ctx: UnaryExprContext): void;
}
export declare class PosUnaryExprContext extends UnaryExprContext {
    OP_ADD(): TerminalNode;
    NUMBER(): TerminalNode;
    constructor(ctx: UnaryExprContext);
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class NegUnaryExprContext extends UnaryExprContext {
    OP_MIN(): TerminalNode;
    NUMBER(): TerminalNode;
    constructor(ctx: UnaryExprContext);
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class StaticIdentifierContext extends ParserRuleContext {
    SECONDS(): TerminalNode | undefined;
    MINUTES(): TerminalNode | undefined;
    HOURS(): TerminalNode | undefined;
    DAYS(): TerminalNode | undefined;
    WEEKS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class RelativeIdentifierContext extends ParserRuleContext {
    MONTHS(): TerminalNode | undefined;
    QUARTERS(): TerminalNode | undefined;
    YEARS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class HandlerContext extends ParserRuleContext {
    RANGE(): TerminalNode | undefined;
    TRAIL(): TerminalNode | undefined;
    PERIOD(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
export declare class TimestampContext extends ParserRuleContext {
    NUMBER(): TerminalNode[];
    NUMBER(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RelativeDateFormatListener): void;
    exitRule(listener: RelativeDateFormatListener): void;
    accept<Result>(visitor: RelativeDateFormatVisitor<Result>): Result;
}
