import { ParseTreeVisitor } from "antlr4ts/tree/ParseTreeVisitor";
import { PosUnaryExprContext } from "./RelativeDateFormatParser";
import { NegUnaryExprContext } from "./RelativeDateFormatParser";
import { RangeDirectiveContext } from "./RelativeDateFormatParser";
import { TrailDirectiveContext } from "./RelativeDateFormatParser";
import { PeriodDirectiveContext } from "./RelativeDateFormatParser";
import { DirectiveContext } from "./RelativeDateFormatParser";
import { RelativeExpressionContext } from "./RelativeDateFormatParser";
import { ResolvableExpressionContext } from "./RelativeDateFormatParser";
import { StaticExpressionContext } from "./RelativeDateFormatParser";
import { StaticPeriodContext } from "./RelativeDateFormatParser";
import { RelativePeriodContext } from "./RelativeDateFormatParser";
import { UnaryExprContext } from "./RelativeDateFormatParser";
import { StaticIdentifierContext } from "./RelativeDateFormatParser";
import { RelativeIdentifierContext } from "./RelativeDateFormatParser";
import { HandlerContext } from "./RelativeDateFormatParser";
import { TimestampContext } from "./RelativeDateFormatParser";
/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by `RelativeDateFormatParser`.
 *
 * @param <Result> The return type of the visit operation. Use `void` for
 * operations with no return type.
 */
export interface RelativeDateFormatVisitor<Result> extends ParseTreeVisitor<Result> {
    /**
     * Visit a parse tree produced by the `posUnaryExpr`
     * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPosUnaryExpr?: (ctx: PosUnaryExprContext) => Result;
    /**
     * Visit a parse tree produced by the `negUnaryExpr`
     * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitNegUnaryExpr?: (ctx: NegUnaryExprContext) => Result;
    /**
     * Visit a parse tree produced by the `RangeDirective`
     * labeled alternative in `RelativeDateFormatParser.directive`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRangeDirective?: (ctx: RangeDirectiveContext) => Result;
    /**
     * Visit a parse tree produced by the `TrailDirective`
     * labeled alternative in `RelativeDateFormatParser.directive`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTrailDirective?: (ctx: TrailDirectiveContext) => Result;
    /**
     * Visit a parse tree produced by the `PeriodDirective`
     * labeled alternative in `RelativeDateFormatParser.directive`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPeriodDirective?: (ctx: PeriodDirectiveContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.directive`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDirective?: (ctx: DirectiveContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.relativeExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRelativeExpression?: (ctx: RelativeExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.resolvableExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitResolvableExpression?: (ctx: ResolvableExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.staticExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStaticExpression?: (ctx: StaticExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.staticPeriod`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStaticPeriod?: (ctx: StaticPeriodContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.relativePeriod`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRelativePeriod?: (ctx: RelativePeriodContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.unaryExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUnaryExpr?: (ctx: UnaryExprContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.staticIdentifier`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStaticIdentifier?: (ctx: StaticIdentifierContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.relativeIdentifier`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRelativeIdentifier?: (ctx: RelativeIdentifierContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.handler`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitHandler?: (ctx: HandlerContext) => Result;
    /**
     * Visit a parse tree produced by `RelativeDateFormatParser.timestamp`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTimestamp?: (ctx: TimestampContext) => Result;
}
