import { AbstractParseTreeVisitor } from "antlr4ts/tree/AbstractParseTreeVisitor";
import { RelativeDateFormatVisitor } from "../lib/lexer-parser/RelativeDateFormatVisitor";
import { RangeDirectiveContext, TrailDirectiveContext, PeriodDirectiveContext, ResolvableExpressionContext, RelativePeriodContext, PosUnaryExprContext, NegUnaryExprContext, RelativeIdentifierContext, StaticExpressionContext, StaticPeriodContext, StaticIdentifierContext } from "../lib/lexer-parser/RelativeDateFormatParser";
import { BaseNode, TimestampNode, RelativeTokenNode, NumberNode, StringNode } from "../ast-nodes";
export declare class RDFFunctionFactory extends AbstractParseTreeVisitor<BaseNode> implements RelativeDateFormatVisitor<BaseNode> {
    protected nowCache: number;
    constructor(now?: number);
    protected now(): number;
    protected defaultResult(): BaseNode;
    visitRangeDirective(ctx: RangeDirectiveContext): BaseNode;
    visitTrailDirective(ctx: TrailDirectiveContext): BaseNode;
    visitPeriodDirective(ctx: PeriodDirectiveContext): BaseNode;
    visitResolvableExpression(ctx: ResolvableExpressionContext): BaseNode;
    visitStaticExpression(ctx: StaticExpressionContext): TimestampNode;
    solveStaticExpression(expr: any): number;
    visitRelativePeriod(ctx: RelativePeriodContext): RelativeTokenNode;
    visitStaticPeriod(ctx: StaticPeriodContext): NumberNode;
    visitNegUnaryExpr(ctx: NegUnaryExprContext): NumberNode;
    visitPosUnaryExpr(ctx: PosUnaryExprContext): NumberNode;
    visitRelativeIdentifier(ctx: RelativeIdentifierContext): StringNode;
    visitStaticIdentifier(ctx: StaticIdentifierContext): StringNode;
}
