"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const antlr4ts_1 = require("antlr4ts");
const RelativeDateFormatParser_1 = require("../lib/lexer-parser/RelativeDateFormatParser");
const RelativeDateFormatLexer_1 = require("../lib/lexer-parser/RelativeDateFormatLexer");
const RDFTestingErrorHandler_1 = require("./RDFTestingErrorHandler");
const RDFFunctionFactory_1 = require("../resolvers/RDFFunctionFactory");
function getTokenListFromString(text) {
    let inputStream = new antlr4ts_1.ANTLRInputStream(text);
    let lexer = new RelativeDateFormatLexer_1.RelativeDateFormatLexer(inputStream);
    let tokenStream = new antlr4ts_1.CommonTokenStream(lexer);
    tokenStream.fill();
    return tokenStream.getTokens().map(token => token.type);
}
exports.getTokenListFromString = getTokenListFromString;
function getParseTreeFromString(text) {
    let inputStream = new antlr4ts_1.ANTLRInputStream(text);
    let lexer = new RelativeDateFormatLexer_1.RelativeDateFormatLexer(inputStream);
    let tokenStream = new antlr4ts_1.CommonTokenStream(lexer);
    let parser = new RelativeDateFormatParser_1.RelativeDateFormatParser(tokenStream);
    parser.addErrorListener(new RDFTestingErrorHandler_1.RDFTestingErrorHandler());
    parser.removeErrorListener(antlr4ts_1.ConsoleErrorListener.INSTANCE);
    return parser.directive();
}
exports.getParseTreeFromString = getParseTreeFromString;
function getFunctionTreeFromDirective(tree, now) {
    var resolver = new RDFFunctionFactory_1.RDFFunctionFactory(now);
    return resolver.visit(tree);
}
exports.getFunctionTreeFromDirective = getFunctionTreeFromDirective;
