/**
 * End to end tests of the RDF function
 */

import 'mocha'
import { expect } from 'chai'
import RDF from '../index'

describe.only("End to end tests", function() {
  // A lot of these cases are stolen from the Function Factory tests and run end to end for completeness
  var cases:[string,number[]][] = [
    ["$range$1561872660$1561872880$", [1561872660, 1561872880]],
    ["$trail$1561872660$1Q$", [1553923860, 1561872660]],
    ["$period$1561872660$10s$1561872665$", [1561872660, 1561872670]]
  ]

  for(let test of cases) {
    it(`${test[0]}`, function() {
      expect(RDF(test[0])).to.be.eql(test[1])
    })
  }
})